<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: ControladorLista_reproduccion.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: ControladorLista_reproduccion.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>'use strict';
var models = require('./../models/');
var listaCanciones = models.lista_cancion;
var listaR = models.lista_reprod;
var persona = models.persona;
var artista = models.artista;
var cancion = models.cancion;
var album = models.album;
var uuid = require('uuid');
var formidable = require('formidable');
var extensiones = ["jpg", "png", "jpeg"];
var maxSize = 20 * 1024 * 1024;
var fs = require('fs');

/**
 * @class ControladorLista_reproduccion
 */
class ControladorLista_reproduccion {

    /**
     * @description Método para visualizar la ventana de ListaReproduccion en la cuál estarán todas las listas que el usuario haya creado
     * @param {req} req Sirve para obtener el nombre del artista, y presentar los mensajes de información o de error
     * @param {res} res Sirve para direccionar a la ventana de ListaReproduccion, y en el caso de que exista un error redireccionará a la ventana principal
     */
    visualizar_listar(req, res) {
        var external = req.user.id;
        var artista_nombre = req.user.artista;
        listaR.findAll().then(function (datos) {
            res.render('index',
                    {
                        title: 'Aureo | Lista de Reproducción',
                        fragmentos: "ListaReproduccion",
                        info: datos,
                        msg: {error: req.flash('error'), info: req.flash('info')}

                    });
        }).error(function (error) {
            req.flash('error', 'Hubo un problema, comunicate con tu servicio del sistema');
            res.redirect('/');
        });
    }

    /**
     * @description Método para visualizar las canciones que se encuentran dentro de la lista de reproducción
     * @param {req} req Sirve para obtener el external id de la lista, y para presentar los mensajes de error o de información
     * @param {res} res Sirve para direccionar a la ventana de VisualizarListaReproduccion, y en el caso de que exista un error redireccionará a la ventana de ListaReproduccion
     */
    visualizar_contenido_listar(req, res) {
        var external_lista = req.params.external;
        listaCanciones.findAll({include: [{model: cancion, as: 'cancion', include: [{model: album, as: 'album', include: [{model: artista, as: 'artistum'}]}]}, {model: listaR, as: 'lista_reprod', where: {external_id: external_lista}}]}).then(function (datos) {
            if (datos) {

                res.render('index',
                        {
                            title: 'Aureo | ' + datos[0].lista_reprod.nom_lista,
                            fragmentos: "VisualizarListaReproduccion",
                            external_lista: external_lista,
                            info: datos,
                            msg: {error: req.flash('error'), info: req.flash('info')}
                        });
            } else {
                req.flash('error', 'La lista está vacia');
                res.redirect('/lista_reproduccion');
            }
        }).error(function (error) {
            req.flash('error', 'Hubo un problema, comunicate con tu servicio del sistema');
            res.redirect('/lista_reproduccion');
        });
    }

    /**
     * @description Método para visualizar la ventana de EditarCaratulaLista en la cuál se podrá subir un archivo de tipo png,jpeg o jpg, para cambiar la imagen de la lista de reproducción
     * @param {req} req Sirve para obtener el external id de la lista de reproducción, el nombre de la lista, y presentar los mensajes de error e información
     * @param {res} res Sirve para direccionar a la ventana de EditarCaratulaLista y en el caso de que exista algún error, redireccionará a la ventana de ListaReproduccion
     */
    visualizar_caratula_listar(req, res) {
        var external = req.params.external;
        var nombre = req.params.nombre;
        listaR.findOne({where: {external_id: external}}).then(function (Datos) {
            res.render('index',
                    {
                        title: 'Aureo | Editar Caratula de la lista de reproduccion',
                        fragmentos: "EditarCaratulaLista",
                        info: Datos,
                        external: external,
                        nombre: nombre,
                        msg: {error: req.flash('error'), info: req.flash('info')}

                    });
        }).error(function (error) {
            req.flash('error', 'Hubo un problema, comunicate con tu servicio del sistema');
            res.redirect('/lista_reproduccion');
        });
    }

    /**
     * @description Método para crear una lista de reproducción
     * @param {req} req Sirve para obtener el external id de la persona, y los datos de la lista de reproducción; además presenta los mensajes de información o error según corresponda.
     * @param {res} res Sirve para redireccionar a la ventana ListaReproduccion en el caso de que haya un error, o de que la operación se haya completado correctamente
     */
    crear_listar(req, res) {
        var external_persona = req.user.id;
        var nombre = req.body.nombre;
        persona.findOne({where: {external_id: external_persona}, include: [{model: listaR, as: 'list_reprod'}]}).then(function (Datos) {
            listaR.findOne({where: {nom_lista: nombre}}).then(function (DatosLista) {
                if (DatosLista === null) {
                    var datos = {
                        nom_lista: req.body.nombre,
                        descripcion: req.body.descripcion,
                        caratula: 'logon.png',
                        id_persona: Datos.id,
                        external_id: uuid.v4()
                    };
                    listaR.create(datos).then(function (ListaDatos) {
                        req.flash('info', "Se ha creado correctamente la lista");
                        res.redirect("/lista_reproduccion");
                    });
                } else {
                    req.flash('error', 'Ya existe una lista de reproducción con ese nombre');
                    res.redirect('/lista_reproduccion');
                }
            });
        });
    }

    /**
     * @description Método para cambiar la caratula de la lista de reproducción
     * @param {req} req Sirve para presentar los mensajes respectivos de información o de error, y también para obtener la imagen que el usuario haya subido en el input llamado "caratula" con el fin de guardar en la carpeta caratulas
     * @param {res} res Sirve para redireccionar a la ventana ListaReproduccion en el caso de que haya un error o de que todo salga bien
     */
    guardar_caratula(req, res) {
        var form = new formidable.IncomingForm();
        form.parse(req, function (err, fields, files) {
            if (files.caratula.size &lt;= maxSize) {
                var extension = files.caratula.name.split(".").pop().toLowerCase();
                if (extensiones.includes(extension)) {
                    var external = fields.external;
                    var nombre = quitarespacios(fields.nombre);
                    var nombreFoto = external + nombre + "." + extension;

                    fs.rename(files.caratula.path, "public/caratulas/" + nombreFoto,
                            function (err) {
                                if (err) {
                                    req.flash('error', "Hubo un error " + err);
                                    res.redirect("/lista_reproduccion");
                                } else {
                                    listaR.findOne({where: {external_id: external}}).then(function (result) {
                                        result.caratula = nombreFoto;
                                        result.save().then(function (ok) {
                                            fs.exists(files.caratula.path, function (exists) {
                                                if (exists)
                                                    fs.unlinkSync(files.caratula.path);
                                            });
                                            req.flash('info', "Se ha cambiado la caratula correctamente");
                                            res.redirect("/lista_reproduccion");
                                        });

                                    });
                                }
                            });

                } else {
                    req.flash('error', "El tipo de archivo no es valido, debe ser png, jpg, o jpeg");
                    res.redirect("/lista_reproduccion");
                }
            } else {
                req.flash('error', "El tamano no puede superar los 20 MB");
                res.redirect("/lista_reproduccion");
            }
        });
    }
}

/**
 * @description Funcion para quitarle los espacios al nombre
 * @param {str} str Obtiene un String al cual le quitará los espacios
 * @returns {quitarespacios.cadena|String} Retorna el String sin espacios
 */
function quitarespacios(str) {
    var cadena = '';
    var arrayString = str.split(' ');
    for (var i = 0; i &lt; arrayString.length; i++) {
        if (arrayString[i] != "") {
            cadena += arrayString[i];
        }
    }
    return cadena;
}
;


module.exports = ControladorLista_reproduccion;</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Classes</h3><ul><li><a href="ControladorLista_reproduccion.html">ControladorLista_reproduccion</a></li></ul><h3>Global</h3><ul><li><a href="global.html#quitarespacios">quitarespacios</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.3</a> on Sun Aug 25 2019 04:13:09 GMT-0500 (GMT-05:00)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
